macroScript ifacemocap
category:"Airon Tools" 
ButtonText:"FACIMA Tools" 
(



 rollout imcRollout "FACIMA Tools" width:355 height:440 
  (	-- begin rollout
	bitmap bmp1 "Bitmap" pos:[100,40] width:253 height:380 enabled:false fileName:"face.jpg"
	colorPicker k_a "" pos:[110,390] width:50 height:20
	colorPicker k_d "" pos:[170,390] width:50 height:20
	colorPicker k_s "" pos:[230,390] width:50 height:20
	spinner factor1 "" pos:[150,90] width:42 height:16 type:#float range:[0.01, 2.0, 1.0] scale:0.01
	spinner factor2 "" pos:[260,90] width:42 height:16 type:#float range:[0.01, 2.0, 1.0]  scale:0.01
	spinner factor3 "" pos:[160,160] width:42 height:16 type:#float range:[0.01, 2.0, 1.0] scale:0.01
	spinner factor4 "" pos:[250,160] width:42 height:16 type:#float range:[0.01, 2.0, 1.0] scale:0.01
	spinner factor5 "" pos:[140,230] width:42 height:16 type:#float range:[0.01, 2.0, 1.0] scale:0.01
	spinner factor6 "" pos:[270,230] width:42 height:16 type:#float range:[0.01, 2.0, 1.0] scale:0.01
	spinner factor7 "" pos:[130,270] width:42 height:16 type:#float range:[0.01, 2.0, 1.0] scale:0.01
	spinner factor8 "" pos:[280,270] width:42 height:16 type:#float range:[0.01, 2.0, 1.0] scale:0.01
	spinner factor9 "" pos:[140,350] width:42 height:16 type:#float range:[0.01, 2.0, 1.0] scale:0.01
	spinner factor10 "" pos:[275,350] width:42 height:16 type:#float range:[0.01, 2.0, 1.0] scale:0.01
	spinner factor11 "" pos:[204,195] width:42 height:16 type:#float range:[0.01, 2.0, 1.0] scale:0.01
	spinner factor12 "" pos:[204,250] width:42 height:16 type:#float range:[0.01, 2.0, 1.0] scale:0.01
	spinner factor13 "" pos:[204,280] width:42 height:16 type:#float range:[0.01, 2.0, 1.0] scale:0.01
	spinner factor14 "" pos:[204,360] width:42 height:16 type:#float range:[0.01, 2.0, 1.0] scale:0.01
	spinner factor15 "" pos:[204,300] width:42 height:16 type:#float range:[0.01, 2.0, 1.0] scale:0.01
	spinner factor16 "" pos:[204,320] width:42 height:16 type:#float range:[0.01, 2.0, 1.0] scale:0.01
	spinner spnframerate "Framerate" pos:[50,110] width:44 height:16 type:#integer range:[1, 60, 25] scale:1
--	label lbl1 "Framerate" pos:[5,110] width:55 height:16
	progressbar progress_bar pos:[3,423] width:349 color:(color 27 197 88)
	spinner pts "Base Pts" pos:[40,225] width:53 height:16 type:#float range:[0.01, 2.0, 0.8] scale:0.01
	
	button apply "Apply" pos:[5,5] width:90 height:30
	button matload "Mat Load" pos:[15,45] width:70 height:20
	button load "Load" pos:[15,75] width:70 height:20
	button load2d "Load 2D" pos:[15,195] width:70 height:20
	button file "File" pos:[15,255] width:70 height:20
	button setdrag "Set Drag" pos:[15,165] width:70 height:20
--	button trans "Do Trans" pos:[15,195] width:70 height:20
	button fastsaveini "Fast save ini" pos:[10,315] width:80 height:20
	button fastloadini "Fast LOAD ini" pos:[10,335] width:80 height:20
	button loadini "LOAD ini" pos:[10,395] width:80 height:20
	button saveini "Save ini" pos:[10,375] width:80 height:20
--	editText edt1 "" pos:[2,140] width:444 height:205    --debug on
	checkbox chk "Defined in file" pos:[260,10] width:90 height:16 enabled:true checked:false
	checkbox chkdrg "Drag Lips" pos:[5,135] width:90 height:16 enabled:true checked:false
	spinner spnbegin "begin" pos:[125,10] width:54 height:16 type:#integer range:[0,9999,0]
	spinner spnend "end" pos:[200,10] width:51 height:16 type:#integer range:[0,9999,150]

on k_a changed _colr do
(
	myface = $'myface'
	if myface == undefined do return 0
	for i = 1 to 15 do
	(
		myface.material[i].k_a = _colr
	)
	gw.updateScreen() 
)

on k_d changed _colr do
(
	myface = $'myface'
	if myface == undefined do return 0
	for i = 1 to 15 do
	(
		myface.material[i].k_d = _colr
	)
	gw.updateScreen() 
)

on k_s changed _colr do
(
	myface = $'myface'
	if myface == undefined do return 0
	for i = 1 to 15 do
	(
		myface.material[i].k_s = _colr
	)
	gw.updateScreen() 
)

on setdrag pressed do with undo on
(
	if 	(dr_aud = $'audiodrag') == undefined do
		dr_aud = point pos:[0,0,0] name:"audiodrag" size:1 box:on
	if 	(dr_spr = $'springdrag') == undefined do
		dr_spr = point pos:[0,0,0] name:"springdrag" size:1 box:on
	if dr_spr.parent != dr_aud do	(
		dr_spr.parent = dr_aud		)
	if classof dr_spr.pos.controller != SpringPositionController do (
		dr_spr.pos.controller = SpringPositionController ()
		displayControlDialog dr_spr.pos.controller ""
		dr_spr.pos.controller.setdampening 1 1 						)
	displayControlDialog dr_spr.pos.controller ""
	if classof dr_aud.pos.controller != AudioPosition do
		dr_aud.pos.controller = AudioPosition ()
	displayControlDialog dr_aud.pos.controller ""
	select dr_aud
)

fn Fsave =
(	
	ffname = (GetDir #maxroot) + "/mocap.fastini"
	 
	if (ff = createfile ffname) == undefined do return 0
	format "%;%;%;%;%;%;%;%;%;%;%;%;%;%;%;%;%;%;%" factor1.value factor2.value factor3.value factor4.value factor5.value factor6.value factor7.value factor8.value factor9.value factor10.value factor11.value factor12.value factor13.value factor14.value factor15.value factor16.value spnend.value chkdrg.checked pts.value to:ff
	close ff	
)

fn Fload =
(
	ffname = (GetDir #maxroot) + "/mocap.fastini"
	
	if (not (doesFileExist ffname)) do return 0
	ff = openfile ffname
	factor1.value = readvalue ff
	factor2.value = readvalue ff
	factor3.value = readvalue ff
	factor4.value = readvalue ff
	factor5.value = readvalue ff
	factor6.value = readvalue ff
	factor7.value = readvalue ff
	factor8.value = readvalue ff
	factor9.value = readvalue ff
	factor10.value = readvalue ff
	factor11.value = readvalue ff
	factor12.value = readvalue ff
	factor13.value = readvalue ff
	factor14.value = readvalue ff
	factor15.value = readvalue ff
	factor16.value = readvalue ff
	spnend.value = readvalue ff
	chkdrg.checked = readvalue ff
	pts.value = readvalue ff
	close ff
)

on imcRollout  open do 
(
	Fload()
	myface = $'myface'
	if classof (try myface.material[15].k_a catch ()) == Color do
	(
		k_a.color = myface.material[1].k_a
		k_d.color = myface.material[1].k_d
		k_s.color = myface.material[1].k_s
	)
)

on imcRollout  close do 
(
	Fsave()
)

on saveini pressed do with undo on
(
	ffname = getsavefilename caption:"Save INI" types:"Ini file (*.ini)|*.ini"
	if ffname == undefined do return 0
	if (ff = createfile ffname) == undefined do return 0
	format "%;%;%;%;%;%;%;%;%;%;%;%;%;%;%;%;%;%;%" factor1.value factor2.value factor3.value factor4.value factor5.value factor6.value factor7.value factor8.value factor9.value factor10.value factor11.value factor12.value factor13.value factor14.value factor15.value factor16.value spnend.value chkdrg.checked pts.value to:ff
	close ff	
)

on fastsaveini pressed do with undo on FSave()


on loadini pressed do with undo on
(
	ffname = getopenfilename caption:"Load INI" types:"Ini file (*.ini)|*.ini"
	if ffname == undefined do ffname = ""
	if (not (doesFileExist ffname)) do return 0
	ff = openfile ffname
	factor1.value = readvalue ff
	factor2.value = readvalue ff
	factor3.value = readvalue ff
	factor4.value = readvalue ff
	factor5.value = readvalue ff
	factor6.value = readvalue ff
	factor7.value = readvalue ff
	factor8.value = readvalue ff
	factor9.value = readvalue ff
	factor10.value = readvalue ff
	factor11.value = readvalue ff
	factor12.value = readvalue ff
	factor13.value = readvalue ff
	factor14.value = readvalue ff
	factor15.value = readvalue ff
	factor16.value = readvalue ff
	spnend.value = readvalue ff
	chkdrg.checked = readvalue ff
	pts.value = readvalue ff
	close ff
)

on fastloadini pressed do with undo on Fload()

fn lowercase instring = 
( 
	upper="ABCDEFGHIJKLMNOPQRSTUVWXYZ" 
	lower="abcdefghijklmnopqrstuvwxyz"
	outstring=copy instring
	for i=1 to outstring.count do
		( 
			j=findString upper outstring[i]
			if (j != undefined) do outstring[i]=lower[j]
		)
	return outstring 
) 

global BoneMatrix = #()
global pxs,pzi
global index = 1 -- strfindnext 
struct FacePoint (obj, pos = #(), ang = #())
global sp = #()
global ip = #()
global	_pointnames = #(#("head_up_up_right","head_up_up_left","head_up_up_right_z"), -- 1
						#("head_up_right_right","head_up_left_left","head_up_right_right_z"),
						#("eye_mid_right_right","eye_mid_left_left","eye_mid_right_right_z"),
						#("eye_mid_right","eye_mid_left","eye_mid_right_z"),
						#("chec_up_right","chec_up_left","chec_up_right_z"),
						#("chec_up_right_right","chec_up_left_left","chec_up_right_right_z"), -- 6
						#("chec_down_right","chec_down_left","chec_down_right_z"),
						#("lips_up_right","lips_up_left","lips_up_right_z"),
						#("lips_down_right","lips_down_left","lips_down_right_z"),
						#("lips_center_right_right_right","lips_center_left_left_left","lips_center_right_right_right_z"),
						#("chec_down_right_right","chec_down_left_left","chec_down_right_right_z"), -- 11
						#("head_down_right_right","head_down_left_left","head_down_right_right_z"), -- 12 
						#("nose_center_center","nose_center_center","nose_center_center_z"), -- 13
						#("nose_down_center","nose_down_center","nose_down_center_z"), -- 14
						#("adam's apple_center","adam's apple_center","adam's apple_center_z"), -- 15
						#("adam's apple_right","adam's apple_left","adam's apple_right_z"), -- 16
						#("adam's apple_right_right","adam's apple_left_left","adam's apple_right_right_z"), -- 17 element 3 names
						#("nose_center_right","nose_center_left"), -- 18
						#("nose_down_right","nose_down_left"), -- 19
						#("nose_down_right_right","nose_down_left_left"), -- 20
						#("lips_center_right","lips_center_left"), -- 21
						#("head_down_right","head_down_left"), -- 22 
						#("head_up_center01"),  -- 23
						#("head_up_center02"), -- 24
						#("nose_up_center"), -- 25
						#("head_up_up_right_right","head_up_up_left_left"), -- 26
						#("head_up_right","head_up_left"), -- 27
						#("lips_up_center"), -- 28
						#("lips_down_center"), -- 29
						#("head_down_center"), -- 30
						#("brown_right_right","brown_left_left"), -- 31
						#("nose_center_right_right","nose_center_left_left"), -- 32
						#("lips_center_right_right","lips_center_left_left"), -- 33
						#("brown_right","brown_left"), -- 34
						#("eye_right","eye_left") -- 35
					   )

fn SetVisZp ip pzi = 
(
	for i = 1 to _pointnames.count do
		if _pointnames[i].count == 3 do
		(
			ip[pzi[i].x].obj.size = pts.value
			ip[pzi[i].y].obj.size = pts.value
		)
)

fn _NameC = -- sopostavlenie imen indeksam
(
	pz = #([1,1,1])
	for p = 1 to 35 do 
	(
		pz[p] = [0,0,0] -- init array for indexes
	)
	for i = 1 to sp.count do
	(
		for p = 1 to 35 do 
		(
			if (lowercase sp[i].obj.name) == _pointnames[p][1] do pz[p].x = i -- tochka originalnaya
			if (lowercase sp[i].obj.name) == _pointnames[p][2] do pz[p].y = i -- tochka mirrored
			if (lowercase sp[i].obj.name) == _pointnames[p][3] do pz[p].z = i -- Z coord
		)
	)
	return pz
)

fn _fNext _string = 
(
	num = "1234567890."
	_value = ""
	done = false
	for i = index to _string.count do 
	(
		if (_string[i] != "\t") and  (_string[i] != " ") then
			(
				
				if ((findstring num _string[i]) != undefined) do append _value _string[i]
				done = true
			) 
		else
			(
				if done do exit
			)
	
		index = i+1
	)
	_value
)
	
fn _sdebugwrite = (	fdebug = openfile "c:\\_sdebug.txt"	)
fn _sreadline sfile = (index = 1; readline sfile)

fn DeleteZts pz =
(
		ppp = #()		
		for i = 1 to 17 do 
			append ppp sp[pz[i].z].obj
		delete ppp
)

fn DrawPoints = 
(
	for i = 1 to sp[1].pos.count do				
	(
		for j = 1 to sp.count do
		(
			sp[j].obj.pos = sp[j].pos[i]
			if sp[j].ang[i] != undefined and sp[j].ang[i] != (matrix3 1) do
				sp[j].obj.transform = sp[j].ang[i] * (matrix3 [1,0,0] [0,1,0] [0,0,1] sp[j].pos)
		)
		slidertime += 1
	)
	return "Draw OK"
)		
fn DrawPointsF f = 
(
		slidertime = f-1
		for j = 1 to sp.count do
		(
			sp[j].obj.pos = sp[j].pos[f]
		)
	return true	
)		


fn CenteringPoints pz =
(
		_pscale = 7.2 / abs(sp[pz[13].x].pos[1].z - sp[pz[30].x].pos[1].z)

		for i = 1 to sp.count do 
			for j = 1 to sp[pz[13].x].pos.count do 
				sp[i].pos[j] = sp[i].pos[j] * _pscale

		for i = 1 to sp[pz[13].x].pos.count do 
			BoneMatrix[i].row4 = BoneMatrix[i].row4 * _pscale

		_xofs = sp[pz[13].x].pos[1].x
		_yofs = sp[pz[13].x].pos[1].y + 6.5
		_zofs = sp[pz[13].x].pos[1].z - 170.2

		for i = 1 to sp.count do 
			for j = 1 to sp[pz[13].x].pos.count do 
				sp[i].pos[j] -= [_xofs,_yofs,_zofs]

		for i = 1 to sp[pz[13].x].pos.count do 
			BoneMatrix[i].row4 -= [_xofs,_yofs,_zofs]

		return "CenterPoints OK"
)

fn spsPaint pz =
(
	for i in #(1,2,23,26) do
		for j = 1 to 3 do
			if _pointnames[i][j] != undefined do
				sp[pz[i][j]].obj.wirecolor = color 154 215 229

	for i in #(3,4) do
		for j = 1 to 3 do
			if _pointnames[i][j] != undefined do
				sp[pz[i][j]].obj.wirecolor = color 227 152 152

	for i in #(5,6,7,10,11,18,20,24,25,27,32,33,35) do
		for j = 1 to 3 do
			if _pointnames[i][j] != undefined do
				sp[pz[i][j]].obj.wirecolor = color 153 228 153
	
	for i in #(8,9,21,28,29) do
		for j = 1 to 3 do
			if _pointnames[i][j] != undefined do
				sp[pz[i][j]].obj.wirecolor = color 141 7 58

	for i in #(12,22,30) do
		for j = 1 to 3 do
			if _pointnames[i][j] != undefined do
				sp[pz[i][j]].obj.wirecolor = color 214 228 153

	for i in #(13,14,19,31,34) do
		for j = 1 to 3 do
			if _pointnames[i][j] != undefined do
				sp[pz[i][j]].obj.wirecolor = color 8 110 134
	
	for i in #(15,16,17) do
		for j = 1 to 3 do
			if _pointnames[i][j] != undefined do
				sp[pz[i][j]].obj.wirecolor = color 8 8 136
)

fn IntersectionXZ A B C P = -- find plane intersection wiht light from x-y coord along z axis
(
	P1 = [P.x,0,0]
	P2 = [P.x,0,0]
	if C.x < B.x do swap C B
	if A.x > B.x do swap A B
	if C.x < B.x do swap C B
	if P.x > B.x do swap A C
	P1.z = A.z + (B.z - A.z)*(P.x-A.x)/(B.x-A.x)
	P2.z = A.z + (C.z - A.z)*(P.x-A.x)/(C.x-A.x)
	P1.y = A.y + (B.y - A.y)*(P1.z-A.z)/(B.z-A.z)
	P2.y = A.y + (C.y - A.y)*(P2.z-A.z)/(C.z-A.z)
	P.y = P2.y + (P1.y - P2.y)*(P.z-P2.z)/(P1.z-P2.z)
	return P
)

fn LoadPointsFromFile ffname rootbone = 
(
	ff = openfile ffname
	seek ff #eof
	ffmaxlen = filepos ff
	seek ff 0
	str = _sreadline ff
	while (fnd = findstring str "b(") == undefined do str = _sreadline ff
	halfxres = (_fNext str as float)/2
	halfyres = (_fNext str as float)/2
	_sscale = 1/(halfyres/18)
	index = 1
	while (fnd = findstring str "b(") == undefined do str = _sreadline ff
	strtmp = substring str fnd (str.count-fnd)
	_fNext strtmp
	animstart = (_fNext strtmp) as integer
	animend = (_fNext strtmp) as integer
	NumFramesInFile = animend
	spstart = (spnbegin.value as integer)
	spend = (spnend.value as integer)
	if animstart  < spstart and (not chk.checked) do animstart = spstart
	if animend  > spend and (not chk.checked) do animend = spend
	animationRange = interval 0 (animend - animstart)
	numpoints = 0 
	while (not eof ff) do 
	(
		while (fnd = findstring str "pointTrack") == undefined do  
			if (not eof ff) do	str = _sreadline ff
		numpoints += 1
		fnd = findstring str "\""						-- find first " of the point name 
		strtmp = substring str (fnd+1) (str.count-fnd)		-- clear first chars before point name
		fnd = findstring strtmp "\"" 						-- find second " of the point name 
		strtmp = substring strtmp 1 (fnd-1) 				-- TAKE POINT NAME
		sp[numpoints] = FacePoint obj:( point pos:[0,0,0] name:strtmp size:0.6 box:on parent:rootbone ) pos:#([0,0,0]) ang:#() -- create point in zero position and adding it to array sp
		if (not eof ff) do str = _sreadline ff
		frame = 1
		if (not eof ff) do
			while (fnd = findstring (str=_sreadline ff) "}" ) == undefined do -- while not end of point coords block ( } )
			(
				tmpi = (_fNext str) as integer 				-- reading frame number
				if (tmpi + 1) < animstart do 
				(
					_skip = animstart - tmpi - 1
					while _skip > 0 do 
					( 
						_skip -= 1
						skiptonextline ff
					)
					str = _sreadline ff
					tmpi = (_fNext str) as integer
				)
				if tmpi >= animstart and tmpi <= animend do
				(
					ffcurlen = filepos ff
					progress_bar.value = 80*ffcurlen/ffmaxlen
					px=(_fNext str) as float -- reading X coord
					py=(_fNext str) as float -- reading Y coord
					pz = 0
					ppos = [px*_sscale,pz,(py-py*2)*_sscale]
					sp[numpoints].pos[frame] = ppos
					frame += 1
				)
				if tmpi > animend do 
				(
					_skip = NumFramesInFile - tmpi
					while _skip >0 do 
					(
						_skip -= 1
						skiptonextline ff
					)
				)
			)
	)
	close ff 
)

fn CountZCoords pz =
(
	BoneMatrix = #()
	ZPt = #()
	m = #()
	_pscale = (sp[pz[1].x].pos[1].z - sp[pz[9].x].pos[1].z)/(sp[pz[1].z].pos[1].z - sp[pz[9].z].pos[1].z)
	for j = 1 to sp[pz[1].x].pos.count do
	(
		for i = 1 to 17 do
		(
			sp[pz[i].x].pos[j].y = sp[pz[i].z].pos[j].x * _pscale
			sp[pz[i].y].pos[j].y = sp[pz[i].z].pos[j].x * _pscale
		)
	)
	
	_spzoffset22 = (sp[pz[10].z].pos[1].x - sp[pz[12].z].pos[1].x)*_pscale
	_spzoffset23 = 0.3*_pscale
	tfsize = (sp[pz[6].x].pos[1].x - sp[pz[14].x].pos[1].x) * 20
	for r = 1 to sp[pz[14].x].pos.count do
	ZPt[r] = copy sp[pz[14].x].pos[r]

	for j = 1 to sp[pz[1].x].pos.count do
	(
		progress_bar.value = 80 + 20*j/sp[pz[1].x].pos.count
		v1 = normalize (sp[pz[1].x].pos[j] - ZPt[j])
		v2 = normalize (sp[pz[2].x].pos[j] - ZPt[j])
		n12 = normalize (cross v1 v2)
		n3 = normalize (cross n12 v2)
		m[j] =  matrix3 v2 n12 n3 [0,0,0]
		mi = inverse m[1]

		BoneMatrix[j] = copy m[j]
		BoneMatrix[j].row4 = ZPt[j]
		mofs = inverse (mi*m[j]) 		-- find offset between m2 and m1
		
		for i = 1 to 17 do				-- rotate all 100% tracked points to first frame space
			sp[pz[i].x].pos[j] = (	sp[pz[i].x].pos[j] - ZPt[j]) * mofs + ZPt[1]
		
	
		sp[pz[18].x].pos[j].y = (sp[pz[5].x].pos[j].y)
		sp[pz[19].x].pos[j].y = ((sp[pz[7].x].pos[j].y - sp[pz[14].x].pos[j].y)/2 + sp[pz[14].x].pos[j].y)
		sp[pz[20].x].pos[j].y = ((sp[pz[7].x].pos[j].y - sp[pz[8].x].pos[j].y)/3 + sp[pz[8].x].pos[j].y)
			dx21 = (sp[pz[21].x].pos[j].x - sp[pz[21].x].pos[1].x)/(sp[pz[21].x].pos[1].x*0.28)
		sp[pz[21].x].pos[j].y = ((sp[pz[10].x].pos[j].y - sp[pz[9].x].pos[j].y)/2 + sp[pz[9].x].pos[j].y)+dx21*(sp[pz[8].x].pos[1].x - sp[pz[28].x].pos[1].x)
		sp[pz[22].x].pos[j].y = sp[pz[12].x].pos[j].y - _spzoffset22
		sp[pz[23].x].pos[j].y = sp[pz[1].x].pos[j].y - _spzoffset23
		sp[pz[24].x].pos[j].y = ((sp[pz[1].x].pos[j].y - sp[pz[13].x].pos[j].y)*0.5 + sp[pz[13].x].pos[j].y)
		sp[pz[25].x].pos[j].y = (sp[pz[13].x].pos[j].y + 0.5*_pscale)
		sp[pz[26].x].pos[j].y = ((sp[pz[2].x].pos[j].y - sp[pz[1].x].pos[j].y)/2 + sp[pz[1].x].pos[j].y)
		sp[pz[27].x].pos[j].y = ((sp[pz[1].x].pos[j].y - sp[pz[4].x].pos[j].y)/3 + sp[pz[4].x].pos[j].y)
--		sp[pz[28].x].pos[j].y = (sp[pz[8].x].pos[j].y*2.035 - sp[pz[10].x].pos[j].y) -- FIRS VARIANT
--		sp[pz[28].x].pos[j].y = sp[pz[8].x].pos[j].y*1.333 - 0.333*sp[pz[10].x].pos[j].y  -- second optimized variant
		sp[pz[28].x].pos[j].y = (sp[pz[8].x].pos[j].y - (sp[pz[10].x].pos[j].y - sp[pz[8].x].pos[j].y)*0.2)  -- third logical variant (like 29)
		if sp[pz[28].x].pos[j].y > sp[pz[19].x].pos[j].y do sp[pz[28].x].pos[j].y = sp[pz[19].x].pos[j].y
		trh28 = (sp[pz[19].x].pos[j].y - sp[pz[14].x].pos[j].y)*0.5 +sp[pz[14].x].pos[j].y
--		if sp[pz[28].x].pos[j].y < trh28 do sp[pz[28].x].pos[j].y = trh28 
		sp[pz[28].x].ang[j] = rotatexmatrix ((sp[pz[19].x].pos[1].y - (sp[pz[19].x].pos[j].y - sp[pz[14].x].pos[1].y )*0.2 - sp[pz[28].x].pos[j].y)/(sp[pz[19].x].pos[j].y - sp[pz[14].x].pos[1].y )*(-90*factor15.value))
		sp[pz[8].x].ang[j] = rotatexmatrix ((sp[pz[19].x].pos[1].y - (sp[pz[19].x].pos[j].y - sp[pz[14].x].pos[1].y )*0.2 - sp[pz[28].x].pos[j].y)/(sp[pz[19].x].pos[j].y - sp[pz[14].x].pos[1].y )*(-60*factor15.value))
		sp[pz[8].y].ang[j] = rotatexmatrix ((sp[pz[19].x].pos[1].y - (sp[pz[19].x].pos[j].y - sp[pz[14].x].pos[1].y )*0.2 - sp[pz[28].x].pos[j].y)/(sp[pz[19].x].pos[j].y - sp[pz[14].x].pos[1].y )*(-60*factor15.value))	

		sp[pz[29].x].pos[j].y = (sp[pz[9].x].pos[j].y - (sp[pz[10].x].pos[j].y - sp[pz[9].x].pos[j].y)*0.2)
		if sp[pz[29].x].pos[j].y > sp[pz[19].x].pos[j].y do sp[pz[28].x].pos[j].y = sp[pz[19].x].pos[j].y
		trh29 = (sp[pz[19].x].pos[j].y - sp[pz[14].x].pos[j].y)*0.5 +sp[pz[14].x].pos[j].y
--		if sp[pz[29].x].pos[j].y < trh28 do sp[pz[28].x].pos[j].y = trh29 
		sp[pz[29].x].ang[j] = rotatexmatrix ((sp[pz[19].x].pos[1].y - (sp[pz[19].x].pos[j].y - sp[pz[14].x].pos[1].y )*0.2 - sp[pz[28].x].pos[j].y)/(sp[pz[19].x].pos[j].y - sp[pz[14].x].pos[1].y )*(90*factor16.value))
		sp[pz[9].x].ang[j] = rotatexmatrix ((sp[pz[19].x].pos[1].y - (sp[pz[19].x].pos[j].y - sp[pz[14].x].pos[1].y )*0.2 - sp[pz[28].x].pos[j].y)/(sp[pz[19].x].pos[j].y - sp[pz[14].x].pos[1].y )*(60*factor16.value))	
		sp[pz[9].y].ang[j] = rotatexmatrix ((sp[pz[19].x].pos[1].y - (sp[pz[19].x].pos[j].y - sp[pz[14].x].pos[1].y )*0.2 - sp[pz[28].x].pos[j].y)/(sp[pz[19].x].pos[j].y - sp[pz[14].x].pos[1].y )*(60*factor16.value))

		sp[pz[30].x].pos[j].y = (sp[pz[12].x].pos[j].y*2 - sp[pz[10].x].pos[j].y)
		sp[pz[31].x].pos[j].y = (sp[pz[4].x].pos[j].y)
		sp[pz[32].x].pos[j].y = ((sp[pz[5].x].pos[j].y - sp[pz[13].x].pos[j].y)/2 + sp[pz[13].x].pos[j].y)
		sp[pz[33].x].pos[j].y = ((sp[pz[10].x].pos[j].y - sp[pz[9].x].pos[j].y)/2 + sp[pz[9].x].pos[j].y)
		sp[pz[34].x].pos[j].y = (sp[pz[13].x].pos[j].y + 1*_pscale)
		sp[pz[35].x].pos[j].y = (sp[pz[5].x].pos[j].y)


		for i in #(1,2,3,4,5,6,7,8,9,10,11,12,16,17) do								-- find mirrored 100% tracked 
		(
			P = copy sp[pz[i].x].pos[j]
			tf = #() 									-- plane on Z - coord of the point
			tf[1] = [sp[pz[14].x].pos[j].x + tfsize, P.y, P.z]
			tf[2] = [sp[pz[14].x].pos[j].x - tfsize/2, P.y, P.z + tfsize*2]
			tf[3] = [sp[pz[14].x].pos[j].x - tfsize/2, P.y, P.z - tfsize*2]

			mback = mi*m[j]
			for i = 1 to 3 do					
				tf[i] = (tf[i] - ZPt[1]) * mback + ZPt[j]					-- rotate this plane to original tracked position

			P = (IntersectionXZ tf[1] tf[2] tf[3] sp[pz[i].y].pos[j])	-- find intersection in orginal point place with rotated plane
			sp[pz[i].y].pos[j] = (P - ZPt[j]) * mofs + ZPt[1]		-- rotate point in first frame space
		)

		for i in #(18,19,20,21,22,26,27,31,32,33,34,35) do		-- find parametrical finded verts
		(
			P = copy sp[pz[i].x].pos[j]
			tf = #() 									-- plane on Z - coord of the point
			tf[1] = [sp[pz[14].x].pos[j].x + tfsize, P.y, P.z]
			tf[2] = [sp[pz[14].x].pos[j].x - tfsize/2, P.y, P.z + tfsize*2]
			tf[3] = [sp[pz[14].x].pos[j].x - tfsize/2, P.y, P.z - tfsize*2]

			mback = mi*m[j] 
			for i = 1 to 3 do					
				tf[i] = (tf[i] - ZPt[1]) * mback + ZPt[j]			-- rotate this plane to original tracked position

			P = (IntersectionXZ tf[1] tf[2] tf[3] P) 			-- find intersection in orginal point place with rotated plane
			PR = (IntersectionXZ tf[1] tf[2] tf[3] sp[pz[i].y].pos[j]) 			-- find intersection in orginal point place with rotated plane
			sp[pz[i].x].pos[j] = (P - ZPt[j]) * mofs + ZPt[1]	-- rotate point in first frame space
			sp[pz[i].y].pos[j] = (PR - ZPt[j]) * mofs + ZPt[1]	-- rotate point in first frame space
		)


		for i in #(23,24,25,28,29,30) do					-- find CENTER parmetrical finded verts
		(
			P = copy sp[pz[i].x].pos[j]
			tf = #()									-- plane on Z - coord of the point
			tf[1] = [sp[pz[14].x].pos[j].x + tfsize, P.y, P.z]
			tf[2] = [sp[pz[14].x].pos[j].x - tfsize/2, P.y, P.z + tfsize*2]
			tf[3] = [sp[pz[14].x].pos[j].x - tfsize/2, P.y, P.z - tfsize*2]

			mback = mi*m[j] 
			for i = 1 to 3 do					
				tf[i] = (tf[i] - ZPt[1]) * mback + ZPt[j]			-- rotate this plane to original tracked position

			P = (IntersectionXZ tf[1] tf[2] tf[3] P) 			-- find intersection in orginal point place with rotated plane
			sp[pz[i].x].pos[j] = (P - ZPt[j]) * mofs + ZPt[1]	-- rotate point in first frame space
		)
		vz = sp[pz[8].x].ang[j].row3
		vx = -(normalize (sp[pz[28].x].pos[j] - sp[pz[8].x].pos[j]))
		vy = normalize (cross vz vx)
		vz = normalize (cross vx vy)
		sp[pz[8].x].ang[j] = matrix3 vx vy vz [0,0,0]

		vz = sp[pz[9].x].ang[j].row3
		vx = -(normalize (sp[pz[29].x].pos[j] - sp[pz[9].x].pos[j]))
		vy = normalize (cross vz vx)
		vz = normalize (cross vx vy)
		sp[pz[9].x].ang[j] = matrix3 vx vy vz [0,0,0]

		vz = sp[pz[8].y].ang[j].row3
		vx = normalize (sp[pz[28].x].pos[j] - sp[pz[8].y].pos[j])
		vy = normalize (cross vz vx)
		vz = normalize (cross vx vy)
		sp[pz[8].y].ang[j] = matrix3 vx vy vz [0,0,0]

		vz = sp[pz[9].y].ang[j].row3
		vx = normalize (sp[pz[29].x].pos[j] - sp[pz[9].y].pos[j])
		vy = normalize (cross vz vx)
		vz = normalize (cross vx vy)
		sp[pz[9].y].ang[j] = matrix3 vx vy vz [0,0,0]

	)
)


fn CountMatBlend pz _face= 
(
	k09 = 0.1/factor9.value
	k10 = 0.1/factor10.value
	
	idFd01 = distance sp[pz[24].x].pos[1] sp[pz[34].y].pos[1]   -- ID First distance
	idFd02 = distance sp[pz[24].x].pos[1] sp[pz[34].x].pos[1]
	
	idFd03 = distance sp[pz[34].y].pos[1] sp[pz[25].x].pos[1]
	idFd04 = distance sp[pz[34].x].pos[1] sp[pz[25].x].pos[1]
	
	idFd05 = distance sp[pz[4].y].pos[1] sp[pz[5].y].pos[1]
	idFd06 = distance sp[pz[4].x].pos[1] sp[pz[5].x].pos[1]
	
	idFd07 = distance ((sp[pz[30].x].pos[1] - sp[pz[14].x].pos[1])/2 + sp[pz[14].x].pos[1]) sp[pz[21].y].pos[1]
	idFd08 = distance ((sp[pz[30].x].pos[1] - sp[pz[14].x].pos[1])/2 + sp[pz[14].x].pos[1]) sp[pz[21].x].pos[1]
	
	idFd09 = (sp[pz[29].x].pos[1].z - sp[pz[30].x].pos[1].z)*k09 -- >1
	idFd10 = (sp[pz[29].x].pos[1].z - sp[pz[30].x].pos[1].z)*k10 
	
	idFd11 = distance sp[pz[13].x].pos[1] sp[pz[25].x].pos[1]
	
	idFd12 = distance ((sp[pz[19].x].pos[1] - sp[pz[19].y].pos[1])/2 + sp[pz[19].y].pos[1])  sp[pz[14].x].pos[1]
	
	idFd13 = distance sp[pz[28].x].pos[1] sp[pz[14].x].pos[1]
	
	idFd14 = distance sp[pz[30].x].pos[1]  sp[pz[14].x].pos[1]
	k01 = idFd01*0.9*factor1.value
	k02 = idFd02*0.9*factor2.value
	k03 = idFd03*0.65*factor3.value
	k04 = idFd04*0.65*factor4.value
	k05 = idFd05*0.65*factor5.value
	k06 = idFd06*0.65*factor6.value
	k07 = idFd07*0.08/factor7.value
	k08 = idFd08*0.08/factor8.value
	k11 = idFd11*0.75*factor11.value
	k12 = idFd12*0.7*factor12.value
	k13 = idFd13*0.5*factor13.value
	k14 = idFd14*0.85*factor14.value
	
	animbuttonstate = on
	for i = 1 to sp[pz[1].x].pos.count do
	(
		slidertime = i
	
		idBd01 = distance sp[pz[24].x].pos[i]  sp[pz[34].y].pos[i]   -- ID First distance
		idBd02 = distance sp[pz[24].x].pos[i]  sp[pz[34].x].pos[i]
		
		idBd03 = distance sp[pz[34].y].pos[i] sp[pz[25].x].pos[i]
		idBd04 = distance sp[pz[34].x].pos[i] sp[pz[25].x].pos[i]
		
		idBd05 = distance sp[pz[4].y].pos[i] sp[pz[5].y].pos[i]
		idBd06 = distance sp[pz[4].x].pos[i] sp[pz[5].x].pos[i]
		
		idBd07 = distance ((sp[pz[30].x].pos[i] - sp[pz[14].x].pos[i])/2 + sp[pz[14].x].pos[i]) sp[pz[21].y].pos[i]
		idBd08 = distance ((sp[pz[30].x].pos[i] - sp[pz[14].x].pos[i])/2 + sp[pz[14].x].pos[i]) sp[pz[21].x].pos[i]
		
		idBd09 = sp[pz[29].x].pos[i].z - sp[pz[21].y].pos[i].z
		idBd10 = sp[pz[29].x].pos[i].z - sp[pz[21].x].pos[i].z
--		idBd09 = (sp[pz[28].x].pos[i].z - sp[pz[29].x].pos[i].z)/2 + sp[pz[29].x].pos[i].z - sp[pz[21].y].pos[i].z
--		idBd10 = (sp[pz[28].x].pos[i].z - sp[pz[29].x].pos[i].z)/2 + sp[pz[29].x].pos[i].z - sp[pz[21].x].pos[i].z
		
		idBd11 = distance sp[pz[13].x].pos[i] sp[pz[25].x].pos[i]
		
		idBd12 = distance ((sp[pz[19].x].pos[i] - sp[pz[19].y].pos[i])/2 + sp[pz[19].y].pos[i]) sp[pz[14].x].pos[i]
		
		idBd13 = distance sp[pz[28].x].pos[i] sp[pz[14].x].pos[i]
		
		idBd14 = distance sp[pz[30].x].pos[i] sp[pz[14].x].pos[i] 
		
		Mat01 = (idBd01 - k01)/(idFd01 - k01)
		if Mat01 > 1 do Mat01 = 1
		if Mat01 < 0 do Mat01 = 0
		_face.material[1].g_TopBumpBlend4 = 1 - Mat01
	
		Mat02 = (idBd02 - k02)/(idFd02 - k02)
		if Mat02 > 1 do Mat02 = 1
		if Mat02 < 0 do Mat02 = 0
		_face.material[2].g_TopBumpBlend4 = 1 - Mat02
	
		Mat03 = (idBd03 - k03)/(idFd03 - k03)
		if Mat03 > 1 do Mat03 = 1
		if Mat03 < 0 do Mat03 = 0
		_face.material[3].g_TopBumpBlend4 = 1 - Mat03
	
		Mat04 = (idBd04 - k04)/(idFd04 - k04)
		if Mat04 > 1 do Mat04 = 1
		if Mat04 < 0 do Mat04 = 0
		_face.material[4].g_TopBumpBlend4 = 1 - Mat04
	
		Mat05 = (idBd05 - k05)/(idFd05 - k05)
		if Mat05 > 1 do Mat05 = 1
		if Mat05 < 0 do Mat05 = 0
		_face.material[5].g_TopBumpBlend4 = 1 - Mat05
	
		Mat06 = (idBd06 - k06)/(idFd06 - k06)
		if Mat06 > 1 do Mat06 = 1
		if Mat06 < 0 do Mat06 = 0
		_face.material[6].g_TopBumpBlend4 = 1 - Mat06
	
		Mat07 = (idBd07 - idFd07)/(idFd07*k07)
		if Mat07 > 1 do Mat07 = 1
		if Mat07 < 0 do Mat07 = 0
		_face.material[7].g_TopBumpBlend4 =  Mat07

		Mat08 = (idBd08 - idFd08)/(idFd08*k08)
		if Mat08 > 1 do Mat08 = 1
		if Mat08 < 0 do Mat08 = 0
		_face.material[8].g_TopBumpBlend4 =  Mat08
	
		Mat09 = idBd09/idFd09
		if Mat09 > 1 do Mat09 = 1
		if Mat09 < 0 do Mat09 = 0
		_face.material[9].g_TopBumpBlend4 = Mat09
	
		Mat10 = idBd10/idFd10
		if Mat10 > 1 do Mat10 = 1
		if Mat10 < 0 do Mat10 = 0
		_face.material[10].g_TopBumpBlend4 = Mat10
	
		Mat11 = (idBd11 - k11)/(idFd11 - k11)
		if Mat11 > 1 do Mat11 = 1
		if Mat11 < 0 do Mat11 = 0
		_face.material[11].g_TopBumpBlend4 = 1 - Mat11
	
		Mat12 = (idBd12 - k12)/(idFd12 - k12)
		if Mat12 > 1 do Mat12 = 1
		if Mat12 < 0 do Mat12 = 0
		_face.material[12].g_TopBumpBlend4 = 1 - Mat12
	
		Mat13 = (idBd13 - k13)/(idFd13 - k13)
		if Mat13 > 1 do Mat13 = 1
		if Mat13 < 0 do Mat13 = 0
		_face.material[13].g_TopBumpBlend4 = 1 - Mat13
	
		Mat14 = (idBd14 - k14)/(idFd14 - k14)
		if Mat14 > 1 do Mat14 = 1
		if Mat14 < 0 do Mat14 = 0
		_face.material[14].g_TopBumpBlend4 = 1 - Mat14
	
	) 
)



on file pressed do with undo on
(	
	target = #(0,1,2)
	for i = 77 to 210 do
		append target i
	ffname = getopenfilename caption:"Open mocap" types:"mocap (*.rz2)|*.rz2"
	if ffname == undefined do ffname = ""
	if (not doesFileExist ffname) do return 0
	fin = openfile ffname
	fout = createfile (ffname + "_crop.rz2")
	str = _sreadline fin
	for i = 1 to 4 do
	(
		format  "%\n" str to:fout
		str = _sreadline fin
	)
	
	while (not eof fin) do
	(
		while (fnd = findstring str "pointTrack") == undefined do  
			if (not eof fin) do
				str = _sreadline fin
		format "%\n{\n" str to: fout
		frame = 0
		str = _sreadline fin
		while (fnd = findstring (str=_sreadline fin) "}" ) == undefined do
		(
			tmpi = (_fNext str) as integer
			for i in target do
			if tmpi == i do 
			(	
				aa = _fNext str
				aai = findstring str aa
				str = "\t" + (frame as string) + "\t" + (substring str aai (str.count-aai))
				format  "%\n" str to:fout
				frame += 1
			)
		)
		format "}\n" to: fout
	)
	close fin
	close fout
)
on matload pressed do with undo on
(
	_face = $'myface'
	if _face == undefined do return 0
	rootbone = $'rootbone'
	if rootbone == undefined do return 0
global	rmas = #()
	ppp = #()
	max select all
	sp = #()
	
	slidertime = 0
	for i in selection do 
		for j = 1 to _pointnames.count do
			for  k = 1 to _pointnames[j].count do
				if i.name == _pointnames[j][k] do 
					append sp (FacePoint obj:i pos:#(i.pos))
	max select none
	disableSceneRedraw()
	append rmas rootbone.transform
	for i = 1 to (animationrange.end as integer / 160) do 
	(
		slidertime = i
		for j = 1 to sp.count do 
			sp[j].pos[i] = sp[j].obj.pos 
		append rmas rootbone.transform
	)
	slidertime = 0
	if rootbone.pos.controller.keys.count > 0 do
	(
		deleteKeys rootbone.pos.controller
		deleteKeys rootbone.rotation.controller
		deleteKeys rootbone.scale.controller
	)


	pz = _NameC()
	a = CountMatBlend pz _face

	for i = 0 to (rmas.count-1) do 
	(
		slidertime = i
		rootbone.transform = rmas[(i+1)]
	)
	enableSceneRedraw()
	animbuttonstate = off
	destroyDialog imcRollout
)
	
	
on spnbegin changed val do
(
	if val > spnend.value do spnend.value  = val
)

on spnend changed val do
(
	if val < spnbegin.value do spnbegin.value  = val
)
   
	
on load2d pressed do with undo off -- load poins without 3d compilation (just any points from file with any points names)
(
	sp = #()		
	bst=animbuttonstate
	animbuttonstate = off
	ffname = getopenfilename caption:"Open mocap" types:"mocap (*.rz2)|*.rz2"
	if ffname == undefined do ffname = ""
	if (not doesFileExist ffname) do return 0
	rootbone = bonesys.createbone [0,1,164] [0,1,172] [0,0,0]
	rootbone.name = "rootbone"
	rootbone.width = 2
	rootbone.height = 2

	LoadPointsFromFile ffname rootbone

	slidertime = 0
	animbuttonstate = true
	disableSceneRedraw()
	for i = 1 to sp[1].pos.count do
	(
		slidertime += 1
		for j = 1 to sp.count do
		(
			sp[j].obj.pos = sp[j].pos[i]
		)
	)
	enableSceneRedraw() 
	animbuttonstate = bst
)
	
   
on load pressed do with undo on
(
	sp = #()
	bst=animbuttonstate
	animbuttonstate = off
	ffname = getopenfilename caption:"Open mocap" types:"mocap (*.rz2)|*.rz2"
	if ffname == undefined do ffname = ""
	if (not doesFileExist ffname) do return 0
	if framerate != spnframerate.value do framerate = spnframerate.value
	local strtmp, fnd1,fnd

	rootbone = bonesys.createbone [0,1,165] [0,1,175] [0,0,0]
	rootbone.name = "rootbone"
	rootbone.width = 2
	rootbone.height = 2

	LoadPointsFromFile ffname rootbone
	
	pz = _NameC() 
	pzs = pz			-- CONVERT NAMES  to indexes
	spsPaint pz 			-- painting color of he points
	CountZCoords pz 		--  CALCULATE Z coords for all points
	CenteringPoints pz 		-- calculate CENTER position

	JawMatrix = #()
	Jaw = [0,0,0] -- pivot of the Jaw bone :)
	Jaw.x = rootbone.pos.x
	Jaw.y = sp[pzs[14].x].pos[1].y + (distance sp[pzs[14].x].pos[1] sp[pzs[15].x].pos[1])*0.9
	Jaw.z = sp[pzs[14].x].pos[1].z
	for i=1 to sp[pzs[15].x].pos.count do
	(
		if sp[pzs[30].x].pos[i].z < sp[pzs[30].x].pos[1].z then
			p1 = sp[pzs[30].x].pos[i]
		else 
			p1 = sp[pzs[30].x].pos[1]
		v1 = normalize (p1 - Jaw)
		v2 = [0,1,0]
		v3 = normalize (cross v2 v1)
		n23 = normalize (cross v1 v3)
		JawMatrix[i] = matrix3 v1 v3 n23 Jaw
	)
	jawbone = bonesys.createbone Jaw ((sp[pzs[30].x].pos[1]-Jaw)*0.8 + Jaw) [0,0,1]
	jawbone.name = "jawbone"
	jawbone.width = 2
	jawbone.height = 2
	jawbone.parent = rootbone

	JDx = jawbone.transform*(inverse JawMatrix[1])


	slidertime = 0
	animbuttonstate = true
	disableSceneRedraw()

	for i = 1 to sp[1].pos.count do		--	draw points animation and jaw animation
	(
		jm = JDx*JawMatrix[i]
		jm.row4 = jawbone.transform.row4
		jawbone.transform = jm
		for j = 1 to sp.count do
		(
			sp[j].obj.pos = sp[j].pos[i]
			if sp[j].ang[i] != undefined and sp[j].ang[i] != (matrix3 1) do
				sp[j].obj.transform = sp[j].ang[i] * (matrix3 [1,0,0] [0,1,0] [0,0,1] sp[j].pos[i])
		)
		slidertime += 1
	)
	slidertime = 0

	ai = inverse BoneMatrix[1]		-- draw rootbone animation
	BDx = rootbone.transform*ai
	for f = 1 to sp[pz[14].x].pos.count do
	(	
		rootbone.transform = BDx*BoneMatrix[f]
		slidertime = f
	)
	
	DeleteZts pz -- delete unneeded points
	enableSceneRedraw() 
	animbuttonstate = bst
	slidertime = 0
	Fsave()
	destroyDialog imcRollout
)

on apply pressed do with undo on
(
	animbuttonstate = true
	ffname = getopenfilename caption:"Open mocap" types:"mocap (*.rz2)|*.rz2"
	if ffname == undefined do ffname = ""
	if (doesFileExist ffname) != true do return 0
	if framerate != spnframerate.value do framerate = spnframerate.value
	max select all
	ip = #()
	sp = #()

	slidertime = 0
	for i in selection do 
		for j = 1 to _pointnames.count do
			for  k = 1 to _pointnames[j].count do
				if i.name == _pointnames[j][k] do 
					append sp (FacePoint obj:i pos:#(i.pos) ang:#())
	for i = 1 to 17 do 
		append sp (FacePoint obj:(point pos:[0,0,0] name:_pointnames[i][3] size:0.6) pos:#([0,0,0]) ang:#())

	pzi = _NameC() -- massiv indexov sootvetstvia dla ip
	
	max select none
	for i = 1 to sp.count do ip[i] = sp[i] -- read initpos from 1st frame
	sp = #()
	rootbone = $'rootbone'
	jawbone = $'jawbone'
	
	LoadPointsFromFile ffname rootbone

	slidertime = 0
	pzs = _NameC() -- CONVERT NAMES  to indexes
	CountZCoords pzs --  CALCULATE Z coords for sp
	CenteringPoints pzs 		-- calculate CENTER position
	SetVisZp ip pzi

	_pscale = abs(ip[pzi[13].x].pos[1].z - ip[pzi[30].x].pos[1].z)/abs(sp[pzs[13].x].pos[1].z - sp[pzs[30].x].pos[1].z)		-- scale to existing face size
	for i = 1 to sp.count do 
		for j = 1 to sp[pzs[13].x].pos.count do 
			sp[i].pos[j] = sp[i].pos[j] * _pscale

	_ofst = sp[pzs[13].x].pos[1] - ip[pzi[13].x].pos[1]		-- offset to existing fase position
	for i = 1 to sp.count do 
		for j = 1 to sp[pzs[13].x].pos.count do 
			sp[i].pos[j] -= _ofst		

	disableSceneRedraw()

	dr_spr = $'springdrag'
	if dr_spr != undefined and chkdrg.checked do	-- dragging points with audio track controller
	(
		for j = 1 to sp[1].pos.count do 
		(
			for i in #(pzs[8].x,pzs[8].y,pzs[28].x) do
				sp[i].pos[j] -= dr_spr.pos
			for i in #(pzs[9].x,pzs[9].y,pzs[29].x) do
				sp[i].pos[j] += dr_spr.pos
			slidertime += 1
		)
	)
	slidertime = 0
	
	if rootbone.pos.controller.keys.count > 0 do
	(
		deleteKeys rootbone.pos.controller
		deleteKeys rootbone.rotation.controller
		deleteKeys rootbone.scale.controller
	)

	if jawbone.pos.controller.keys.count > 0 do
	(
		deleteKeys jawbone.pos.controller
		deleteKeys jawbone.rotation.controller
		deleteKeys jawbone.scale.controller
	)
	
	for j = 1 to 35 do for k = 1 to _pointnames[j].count do if k < 3 do 
	(	
		deleteKeys ip[pzi[j][k]].obj.pos.controller
		deleteKeys ip[pzi[j][k]].obj.rotation.controller
		deleteKeys ip[pzi[j][k]].obj.scale.controller
	)
	

	JawMatrix = #()
	Jaw = [0,0,0] -- pivot of the Jaw bone :)
	Jaw.x = rootbone.pos.x
	Jaw.y = sp[pzs[14].x].pos[1].y + (distance sp[pzs[14].x].pos[1] sp[pzs[15].x].pos[1])*0.9
	Jaw.z = sp[pzs[14].x].pos[1].z
	for i=1 to sp[pzs[15].x].pos.count do
	(
		if sp[pzs[30].x].pos[i].z < sp[pzs[30].x].pos[1].z then
			p1 = sp[pzs[30].x].pos[i]
		else 
			p1 = sp[pzs[30].x].pos[1]
		v1 = normalize (p1 - Jaw)
		v2 = [0,1,0]
		v3 = normalize (cross v2 v1)
		n23 = normalize (cross v1 v3)
		JawMatrix[i] = matrix3 v1 v3 n23 Jaw
	)
	JDx = jawbone.transform*(inverse JawMatrix[1])

	animbuttonstate = true
	for i = 1 to sp[1].pos.count do				
	(
		jm = JDx*JawMatrix[i]
		jm.row4 = jawbone.transform.row4
		jawbone.transform = jm
		
		for j = 1 to _pointnames.count do
			for k = 1 to _pointnames[j].count do
			(
				if _pointnames[j][k] != undefined and k < 3 do 
				(
					ip[pzi[j][k]].obj.pos = ip[pzi[j][k]].pos[1] + ( sp[pzs[j][k]].pos[i] - sp[pzs[j][k]].pos[1])
					if sp[pzs[j][k]].ang[i] != undefined and sp[pzs[j].x].ang[k] != (matrix3 1) do
						ip[pzi[j][k]].obj.transform = sp[pzs[j][k]].ang[i] *(matrix3 [1,0,0] [0,1,0] [0,0,1] ip[pzi[j][k]].obj.pos)
				)
			)
		slidertime += 1
	)

	
	
	slidertime = 0
	ai = inverse BoneMatrix[1]
	BDx = rootbone.transform*(inverse BoneMatrix[1]) -- offset between bone matrix in first frame and first matrix in animation array
	for f = 1 to sp[pzs[14].x].pos.count do
	(	
		rootbone.transform = BDx*BoneMatrix[f] -- now we take only a offset 
		slidertime = f
	)
	slidertime = 0
	max select none
	ppp = #()
	for i = 1 to sp.count do append ppp sp[i].obj
	delete ppp
	ppp = #()
	for i = 1 to 17 do append ppp ip[pzi[i].z].obj
	delete ppp
	
	
	enableSceneRedraw()
	animbuttonstate = false
	Fsave()
	destroyDialog imcRollout

		
)
	
)	-- end rollout

	on execute do ( createDialog imcRollout; checked = true )

	on closeDialogs do destroyDialog imcRollout

	on isChecked return (checked)
)

--	buttontext:"About..." category:"FACIMA"
macroScript facima_about
category:"Airon Tools" 
ButtonText:"FACIMA About"

(
	rollout AboutGLBasic "AboutFACIMA" width:296 height:152
	(	 
		bitmap bmp1 "Bitmap" pos:[8,8] width:280 height:80 fileName: "FacimaLogo.bmp" 
		button btn1 "Ok" pos:[104,140] width:88 height:24
		label lbl13 "CDDL Common Development and Distribution License, 2011 develop by Airon LLC, Skyfallen LLC" pos:[10,96] width:275 height:30 align:#right style_sunkenedge:true
		on btn1 pressed do destroyDialog AboutGLBasic
	)
	
	createDialog AboutGLBasic 296 172
)

(

local mainMenu = menuMan.getMainMenuBar()

local subMenu = menuMan.createMenu "FACIMA Tools"
	
local myItem = menuMan.createActionItem "ifacemocap" "Airon Tools"

myItem.setTitle "FACIMA..."
myItem.setUseCustomTitle true

subMenu.addItem myItem -1

local myItem = menuMan.createActionItem "facima_about" "Airon Tools"

myItem.setTitle "About FACIMA..."
myItem.setUseCustomTitle true

subMenu.addItem myItem -1


local subMenuItem = menuMan.createSubMenuItem "FACIMA Tools" subMenu

local exportSelectedIndex
local addItem = true
for i = 1 to (mainMenu.numItems()) do (
local item = mainMenu.getItem i
local itemTitle = item.getTitle()
if (itemTitle == "FACIMA Tools") then ( addItem = false; exit )
else if (itemTitle == "Help" or itemTitle == "&Help") then ( exportSelectedIndex = i )

)
if (addItem AND (exportSelectedIndex != undefined)) then (
mainMenu.addItem subMenuItem (exportSelectedIndex+1)
)
menuMan.updateMenuBar()
)